Update health check regression tests
authorMathieu Desnoyers <mathieu.desnoyers@efficios.com>
Wed, 9 Oct 2013 18:32:31 +0000 (14:32 -0400)
committerMathieu Desnoyers <mathieu.desnoyers@efficios.com>
Wed, 9 Oct 2013 19:36:05 +0000 (15:36 -0400)
Update to new health_check program output.

Signed-off-by: Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
tests/regression/tools/health/test_thread_exit
tests/regression/tools/health/test_thread_stall
tests/regression/tools/health/test_tp_fail

index b4fc73d052a3091a48c78704e800137695bf6469..ea0b4d4ea1d99cb1d01ee124d051241757e27659 100755 (executable)
@@ -35,7 +35,7 @@ fi
 function test_thread_exit
 {
        test_thread_exit_name="$1"
-       test_thread_exit_code="$2"
+       test_thread_error_string="$2"
 
        diag "Test health failure with ${test_thread_exit_name}"
 
@@ -56,26 +56,35 @@ function test_thread_exit
        unset ${test_thread_exit_name}_EXIT
 
        # Check initial health status
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
+       $CURDIR/$HEALTH_CHECK_BIN > /dev/null
 
        # Wait
        sleep 30
 
-       # Check health status, exit code should indicate failure
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
+       # Check health status
+       $CURDIR/$HEALTH_CHECK_BIN > ${STDOUT_PATH} 2> ${STDERR_PATH}
 
-       health_check_exit_code=$?
-
-       if [ $health_check_exit_code -eq $test_thread_exit_code ]; then
-               pass "Validate thread ${test_thread_exit_name} failure"
-               stop_lttng_sessiond
-       else
+       out=$(grep "${test_thread_error_string}" ${STDOUT_PATH} | wc -l)
+       if [ $out -eq 0 ]; then
                fail "Validate thread ${test_thread_exit_name} failure"
-
-               diag "Health returned: $health_check_exit_code\n"
+               diag "Health returned:"
+               diag "stdout:"
+               file=${STDOUT_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
+
+               diag "stderr:"
+               file=${STDERR_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
 
                stop_lttng_sessiond
                return 1
+       else
+               pass "Validate thread ${test_thread_exit_name} failure"
+               stop_lttng_sessiond
        fi
 }
 
@@ -87,13 +96,19 @@ THREAD=("LTTNG_THREAD_MANAGE_CLIENTS"
        "LTTNG_THREAD_MANAGE_APPS"
        "LTTNG_THREAD_REG_APPS")
 
-# Exit code value to indicate specific thread failure
-EXIT_CODE=(1 2 4)
+ERROR_STRING=(
+       "Thread \"Session daemon command\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application manager\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application registration\" is not responding in component \"sessiond\"."
+)
+
+STDOUT_PATH=$(mktemp)
+STDERR_PATH=$(mktemp)
 
 THREAD_COUNT=${#THREAD[@]}
 i=0
 while [ "$i" -lt "$THREAD_COUNT" ]; do
-       test_thread_exit "${THREAD[$i]}" "${EXIT_CODE[$i]}"
+       test_thread_exit "${THREAD[$i]}" "${ERROR_STRING[$i]}"
 
        if [ $? -eq 1 ]; then
                exit 1
@@ -111,9 +126,11 @@ fi
 
 skip $isroot "Root access is needed. Skipping LTTNG_THREAD_MANAGE_KERNEL tests." "3" ||
 {
-       test_thread_exit "LTTNG_THREAD_MANAGE_KERNEL" "8"
+       test_thread_exit "LTTNG_THREAD_MANAGE_KERNEL" "Thread \"Session daemon kernel\" is not responding in component \"sessiond\"."
 }
 
+rm -f ${STDOUT_PATH}
+rm -f ${STDERR_PATH}
 
 # TODO: Special case manage consumer, need to spawn consumer via commands.
 #"LTTNG_THREAD_MANAGE_CONSUMER"
index ddaab9542bf98d32ba73d55f89bbec246e8e8d62..0c8244d5c98d738bf719f8fc608094d44c16eb4e 100755 (executable)
@@ -56,45 +56,64 @@ function test_thread_stall
        unset ${test_thread_stall_name}_STALL
 
        # Check initial health status
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
+       $CURDIR/$HEALTH_CHECK_BIN > /dev/null
 
        # Wait
        sleep 30
 
-       # Check health status, exit code should indicate failure
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
-
-       health_check_exit_code=$?
-
-       if [ $health_check_exit_code -eq $test_thread_exit_code ]; then
-               pass "Validate that ${test_thread_stall_name} is stalled"
-       else
-               fail "Validate that ${test_thread_stall_name} is stalled"
-               diag "Health returned: $health_check_exit_code"
+       # Check health status, should indicate failure
+       $CURDIR/$HEALTH_CHECK_BIN > ${STDOUT_PATH} 2> ${STDERR_PATH}
+
+       out=$(grep "${test_thread_error_string}" ${STDOUT_PATH} | wc -l)
+       if [ $out -eq 0 ]; then
+               fail "Validate thread ${test_thread_stall_name} is stalled"
+               diag "Health returned:"
+               diag "stdout:"
+               file=${STDOUT_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
+
+               diag "stderr:"
+               file=${STDERR_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
 
                stop_lttng_sessiond
                return 1
+       else
+               pass "Validate thread ${test_thread_stall_name} is stalled"
        fi
 
        # Wait
        sleep 40
 
-       # Check health status, exit code should now pass
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
-
-       health_check_exit_code=$?
+       # Check health status, should now pass
+       $CURDIR/$HEALTH_CHECK_BIN > ${STDOUT_PATH} 2> ${STDERR_PATH}
+
+       out=$(grep "${test_thread_error_string}" ${STDOUT_PATH} | wc -l)
+       if [ $out -ne 0 ]; then
+               fail "Validate thread ${test_thread_stall_name} is not longer stalled"
+               diag "Health returned:"
+               diag "stdout:"
+               file=${STDOUT_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
+
+               diag "stderr:"
+               file=${STDERR_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
 
-       if [ $health_check_exit_code -eq 0 ]; then
-               pass "Validate that ${test_thread_stall_name} is no longer stalled"
                stop_lttng_sessiond
+               return 1
        else
-               fail "Validate that ${test_thread_stall_name} is no longer stalled"
-               diag "Health returned: $health_check_exit_code\n"
+               pass "Validate thread ${test_thread_stall_name} is not longer stalled"
                stop_lttng_sessiond
-               return 1
        fi
-
-
 }
 
 plan_tests $NUM_TESTS
@@ -108,16 +127,19 @@ THREAD=("LTTNG_THREAD_MANAGE_CLIENTS"
 #      "LTTNG_THREAD_REG_APPS"
 )
 
-# Exit code value to indicate specific thread failure
-EXIT_CODE=(1
-          2
-#         4
+ERROR_STRING=(
+       "Thread \"Session daemon command\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application manager\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application registration\" is not responding in component \"sessiond\"."
 )
 
+STDOUT_PATH=$(mktemp)
+STDERR_PATH=$(mktemp)
+
 THREAD_COUNT=${#THREAD[@]}
 i=0
 while [ "$i" -lt "$THREAD_COUNT" ]; do
-       test_thread_stall "${THREAD[$i]}" "${EXIT_CODE[$i]}"
+       test_thread_stall "${THREAD[$i]}" "${ERROR_STRING[$i]}"
 
        if [ $? -eq 1 ]; then
                exit 1
@@ -135,5 +157,8 @@ fi
 
 skip $isroot "Root access is needed. Skipping LTTNG_THREAD_MANAGE_KERNEL tests." "4" ||
 {
-       test_thread_stall "LTTNG_THREAD_MANAGE_KERNEL" "8"
+       test_thread_stall "LTTNG_THREAD_MANAGE_KERNEL" "Thread \"Session daemon kernel\" is not responding in component \"sessiond\"."
 }
+
+rm -f ${STDOUT_PATH}
+rm -f ${STDERR_PATH}
index c7db62488f7bb42b00dd5e35c50ce7bc59e60dce..591d60835f5a677b5f0b262d25eadd067ddb1baf 100755 (executable)
@@ -35,7 +35,7 @@ fi
 function test_tp_fail
 {
        test_tp_fail_name="$1"
-       test_tp_fail_code="$2"
+       test_tp_error_string="$2"
 
        diag "Test health failure with ${test_tp_fail_name}"
 
@@ -53,19 +53,31 @@ function test_tp_fail
        unset LD_PRELOAD
        unset ${test_tp_fail_name}_TP_FAIL
 
-       # Check health status, exit code should indicate failure
-       $CURDIR/$HEALTH_CHECK_BIN &> /dev/null
+       # Check health status
+       $CURDIR/$HEALTH_CHECK_BIN > ${STDOUT_PATH} 2> ${STDERR_PATH}
 
-       health_check_exit_code=$?
+       out=$(grep "${test_tp_error_string}" ${STDOUT_PATH} | wc -l)
+       if [ $out -eq 0 ]; then
+               fail "Validate thread ${test_tp_fail_name} failure"
+               diag "Health returned:"
+
+               diag "stdout:"
+               file=${STDOUT_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
+
+               diag "stderr:"
+               file=${STDERR_PATH}
+               while read line ; do
+                   diag "$line"
+               done < ${file}
 
-       if [ $health_check_exit_code -eq $test_tp_fail_code ]; then
-               pass "Validate thread ${test_tp_fail_name} failure"
                stop_lttng_sessiond
+               return 1
        else
-               fail "Validate thread ${test_tp_fail_name} failure"
-               diag "Health returned: $health_check_exit_code"
+               pass "Validate thread ${test_tp_fail_name} failure"
                stop_lttng_sessiond
-               return 1
        fi
 }
 
@@ -76,13 +88,18 @@ print_test_banner "$TEST_DESC"
 THREAD=("LTTNG_THREAD_MANAGE_CLIENTS"
        "LTTNG_THREAD_MANAGE_APPS")
 
-# Exit code value to indicate specific thread failure
-EXIT_CODE=(1 2)
+ERROR_STRING=(
+       "Thread \"Session daemon command\" is not responding in component \"sessiond\"."
+       "Thread \"Session daemon application manager\" is not responding in component \"sessiond\"."
+)
+
+STDOUT_PATH=$(mktemp)
+STDERR_PATH=$(mktemp)
 
 THREAD_COUNT=${#THREAD[@]}
 i=0
 while [ "$i" -lt "$THREAD_COUNT" ]; do
-       test_tp_fail "${THREAD[$i]}" "${EXIT_CODE[$i]}"
+       test_tp_fail "${THREAD[$i]}" "${ERROR_STRING[$i]}"
 
        if [ $? -eq 1 ]; then
                exit 1
@@ -100,9 +117,11 @@ fi
 
 skip $isroot "Root access is needed. Skipping LTTNG_THREAD_MANAGE_KERNEL tests." "3" ||
 {
-       test_tp_fail "LTTNG_THREAD_MANAGE_KERNEL" "8"
+       test_tp_fail "LTTNG_THREAD_MANAGE_KERNEL" "Thread \"Session daemon kernel\" is not responding in component \"sessiond\"."
 }
 
+rm -f ${STDOUT_PATH}
+rm -f ${STDERR_PATH}
 
 # TODO: Special case manage consumer, need to spawn consumer via commands.
 #"LTTNG_THREAD_MANAGE_CONSUMER"
This page took 0.03072 seconds and 5 git commands to generate.